//+------------------------------------------------------------------+
//|                                                           mladen |
//+------------------------------------------------------------------+
#property  indicator_separate_window
#property  indicator_buffers 3
#property  indicator_color1  Gray
#property  indicator_color2  White
#property  indicator_color3  Lime

//
//
//
//
//

extern int     FastEMA       =12;
extern int     SlowEMA       =26;
extern int     SignalSMA     = 9;
extern int     PriceType     = 0;
extern string  timeFrame     ="H1";

//
//
//
//

double     SignalBuffer[];
double     MacdBuffer[];
double     OutlBuffer[];

//
//
//
//
//

datetime TimeArray[];
int      TimeFrame;
int      correction;


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int init()
{
   SetIndexBuffer(0,MacdBuffer);
   SetIndexBuffer(1,OutlBuffer);
   SetIndexBuffer(2,SignalBuffer);
   SetIndexLabel(0,"MACD");
   SetIndexLabel(1,NULL);
   SetIndexLabel(2,"Signal");
   SetIndexStyle(0,DRAW_HISTOGRAM);
   
   //
   //
   //
   //
   //
   
   TimeFrame=stringToTimeFrame(timeFrame);
      IndicatorDigits(Digits+1);
      IndicatorShortName("mtf.MACD ("+TimeFrameToString(TimeFrame)+","+PriceTypeToString(PriceType)+") ("+FastEMA+","+SlowEMA+","+SignalSMA+")");
   
   //
   //
   //
   //
   //

   correction = MathMax(FastEMA,MathMax(SlowEMA,SignalSMA));
   SignalSMA = SignalSMA*TimeFrame/Period();
      for (int i=0;i<indicator_buffers;i++) SetIndexDrawBegin(i,correction);
   return(0);
}

//
//
//
//
//

int deinit()
{
   return(0);
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int start()
{
   int      counted_bars=IndicatorCounted();
   int      limit,i,y=0;


   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;

      ArrayCopySeries(TimeArray ,MODE_TIME ,NULL,TimeFrame);
      
   //
   //
   //
   //
   //
   
      for(i=0;i<limit;i++)
         {
            if (Time[i]<TimeArray[y]) y++;
               MacdBuffer[i] = miMa(i,FastEMA,y)-miMa(i,SlowEMA,y);
               OutlBuffer[i] = MacdBuffer[i];
         }         
      for(i=0; i<limit; i++)  SignalBuffer[i]=iMAOnArray(MacdBuffer,Bars,SignalSMA,0,MODE_SMA,i);
      
   //
   //
   //
   //
   //
         
   return(0);
}


//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//
//
//
//
//

double miMa(int i,int maPeriod,int shift)
{
   double previous = 0.0;
   double pr       = 2.0 / (maPeriod+1);
   double price;
   


   previous = iMA(NULL,TimeFrame,maPeriod,0,MODE_EMA,PriceType,shift+1);

   //
   //
   //
   //
   //
   
   switch (PriceType)
      {
         case 0: price = Close[i];    break;
         case 1: price = Open[shift]; break;
         default :
            
            //
            //
            //
            //
            //
            
            for(int t=i;t>Bars;t++) if (Time[t] < TimeArray[shift]) break;
               double high = High[iHighest(NULL,0,MODE_HIGH,t-i+1,i)];
               double low  =   Low[iLowest(NULL,0,MODE_LOW ,t-i+1,i)];

            //
            //
            //
            //
            //
                           
            switch (PriceType)
               {
                  case 2: price = high;                           break;
                  case 3: price = low;                            break;
                  case 4: price = (high+low)/2;                   break;
                  case 5: price = (high+low+Close[i])/3;          break;
                  case 6: price = (high+low+Close[i]+Close[i])/4; break;
               }                     
      }         
   return(price*pr+previous*(1-pr));
}


//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//
//
//
//
//

string PriceTypeToString(int pt)
{
   string answer;
   switch(pt)
   {
      case 0:  answer = "Close"    ; break; 
      case 1:  answer = "Open"     ; break;
      case 2:  answer = "High"     ; break;
      case 3:  answer = "Low"      ; break;
      case 4:  answer = "Median"   ; break;
      case 5:  answer = "Typical"  ; break;
      case 6:  answer = "Wighted"  ; break;
      default: answer = "Invalid price field requested";
                                    Alert(answer);
   }
   return(answer);
}
int stringToTimeFrame(string tfs)
{
   int tf=0;
       tfs = StringUpperCase(tfs);
         if (tfs=="M1" || tfs=="1")     tf=PERIOD_M1;
         if (tfs=="M5" || tfs=="5")     tf=PERIOD_M5;
         if (tfs=="M15"|| tfs=="15")    tf=PERIOD_M15;
         if (tfs=="M30"|| tfs=="30")    tf=PERIOD_M30;
         if (tfs=="H1" || tfs=="60")    tf=PERIOD_H1;
         if (tfs=="H4" || tfs=="240")   tf=PERIOD_H4;
         if (tfs=="D1" || tfs=="1440")  tf=PERIOD_D1;
         if (tfs=="W1" || tfs=="10080") tf=PERIOD_W1;
         if (tfs=="MN" || tfs=="43200") tf=PERIOD_MN1;
         if (tf<Period()) tf=Period();
  return(tf);
}
string TimeFrameToString(int tf)
{
   string tfs="Current time frame";
   switch(tf) {
      case PERIOD_M1:  tfs="M1"  ; break;
      case PERIOD_M5:  tfs="M5"  ; break;
      case PERIOD_M15: tfs="M15" ; break;
      case PERIOD_M30: tfs="M30" ; break;
      case PERIOD_H1:  tfs="H1"  ; break;
      case PERIOD_H4:  tfs="H4"  ; break;
      case PERIOD_D1:  tfs="D1"  ; break;
      case PERIOD_W1:  tfs="W1"  ; break;
      case PERIOD_MN1: tfs="MN1";
   }
   return(tfs);
}

//
//
//
//
//

string StringUpperCase(string str)
{
   string   s = str;
   int      tchar;
   
   for(int i=StringLen(str)-1; i>=0; i--)
      {
         tchar = StringGetChar(s, i);
         
         //
         //
         //
         //
         //
         
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                  s = StringSetChar(s, i, tchar - 32);
          else 
              if(tchar > -33 && tchar < 0)
                  s = StringSetChar(s, i, tchar + 224);
                  
   }
   
   //
   //
   //
   //
   //
   
   return(s);
}